'*****************************************
'*                                       *
'*  Script angepasst durch:              *
'*  Felix Gorgas                         *
'*                                       *
'*  Vorlage erstellt durch:              *
'*  ISD Software und Systeme 2010        *
'*                                       *
'*****************************************

Option Explicit

Dim MySheetName1
Dim K
Dim K1
Dim I
Dim Range
Dim MyTableLength
Dim Args,strFile,objExcel,objWorkbook
Dim TextTable32,TextTable64,TextTable,mapFile,mapId,text
Dim MyHomeDir 
Dim Picture
Dim MyIndex(3,100)
Dim MySheetIndex(4)
Dim InTable
Const xlAutomatic = -4.105 
Const xlNone = -4142 
Const xlContinuous = 1 
Const xlThin = 2 
Const xlDiagonalDown = 5 
Const xlDiagonalUp = 6 
Const xlEdgeLeft = 7 
Const xlEdgeTop = 8 
Const xlEdgeBottom = 9 
Const xlEdgeRight = 10 
Const xlInsideVertical = 11 
Const xlInsideHorizontal = 12 
Const HKEY_CLASSES_ROOT 	= &H80000000
Const HKEY_CURRENT_USER 	= &H80000001
Const HKEY_LOCAL_MACHINE 	= &H80000002
Const HKEY_USERS 		= &H80000003
Const HKEY_CURRENT_CONFIG 	= &H80000005
Dim MaxCrit
Dim Crit(20)

Function MyFilter (Attribute)
	Dim K
	Dim HLP
	
	HLP = False
	For K = 1 To MaxCrit
    	If CStr (Attribute) = CStr (Crit(K)) Then
    		HLP = True
    	End if
    Next 
    MyFilter = HLP
End Function

Function GetMyMapfile
	Dim objWshShell, strSchluessel, strWert, HomePath
	Set objWshShell = CreateObject("WScript.Shell")
	strSchluessel = "HKEY_LOCAL_MACHINE\SOFTWARE\ISD Software und Systeme\HiCAD\1700.0\HomeDir"
	HomePath = objWshShell.RegRead(strSchluessel)
	If Len(HomePath) = 0 Then
		strSchluessel = "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\ISD Software und Systeme\HiCAD\1700.0\HomeDir"
		HomePath = objWshShell.RegRead(strSchluessel)
	End If	
	If Len(HomePath) = 0 Then
		HomePath = ".\"
	End If
	MyHomeDir = HomePath
	strSchluessel = "HKEY_CURRENT_USER\Software\ISD Software und Systeme\HiCAD 2012\ISDTextTable\Language1"
	strWert = objWshShell.RegRead(strSchluessel)
	If Len(strWert) = 0 Then
		strWert = 1000
	End If
	GetMyMapfile = HomePath + "HICAD TextFiles\TEXTMAP" + strWert + ".map"
End Function

Function  GetTableLength(ExcelObj, SheetName)
	Dim Found
	Dim MyCell
	Found = False
	MyCell=4
	While Not Found
		MyCell = MyCell + 1
		If Len(Trim(ExcelObj.Worksheets(SheetName).Cells(MyCell,1).Value)) = 0 Then
			Found = True
		End If
	Wend	
	GetTableLength = MyCell - 1
End Function

Sub InitIndex(objExcel)
	Dim SheetName
	Dim AttributeName
	Dim Ready 
	Dim I,K
	Dim BufStr
	
	K = 0
	For I = 1 To 3
		MySheetIndex(I) = objExcel.Worksheets(I).name
		Ready = False
		K = 0
		While Not Ready
			K = K + 1
			BufStr = objExcel.Worksheets(I).cells(K).value
			If BufStr = "" Then 
				Ready = True
			Else
				MyIndex(I,K) = BufStr
			End If
		Wend
	next
End Sub	

Function GetIndex(SheetName , AttributeName)	
	Dim Found
	Dim K
	Dim I
	Dim AUS
	AUS = -1
	Found = False
	I = 0
	While Not Found
		I = I + 1
		If MySheetIndex(I) = SheetName Then
			Found = True
		End If
	Wend	
	Found = False
	K = 0
	While Not Found
		K = K + 1
		If MyIndex(I,K) = "" Or MyIndex(I,K) = AttributeName Then
			Found = True
			If MyIndex(I,K) = AttributeName Then 
				AUS = K
			End If
		End If
	Wend
	GetIndex = AUS
End Function
	
Function GetContent(ExcelObj, SheetName , AttributeName , Line)
	Dim MyCell
	MyCell = GetIndex(SheetName , AttributeName)
	If MyCell >= 0 Then
		GetContent = ExcelObj.Worksheets(SheetName).Cells(Line,MyCell).Value	
	Else
		GetContent = "#ERROR#"
	End If
End Function

Sub ISDInitTextService()
	On Error Resume Next
	Set TextTable32=CreateObject("ISDTextTables.TextTable")
	Set TextTable=TextTable32
	mapFile = GetMyMapfile
	mapId=TextTable.ReloadMapFile(mapFile)	
	if Err.Number > 0 Then
		Set TextTable64=CreateObject("ISDTextTables64.TextTable64")
		Set TextTable=TextTable64
		mapFile = GetMyMapfile
		mapId=TextTable.ReloadMapFile(mapFile)	
	End If	
	On Error Goto 0
End sub

Function ISDGetText(Ein) 
    dim Aus
    Aus = TextTable.GetMapText(mapId,Ein)
    If Len (Aus)=0 Then
    	Aus = Ein
    End If
	ISDGetText = Aus
End Function


'Schleife fr die Form des Kopfes - hier mit Excel Befehlen arbeiten
Sub CreateBOM(ListName , ListSource, FilterAttribute, Positive)
   MySheetName1 = ISDGetText(ListName)
   objExcel.Sheets.Add.Name = MySheetName1 
   objExcel.columns(1).columnwidth = 6 
   objExcel.columns(2).columnwidth = 6
   objExcel.columns(3).columnwidth = 33
   objExcel.columns(6).columnwidth = 16
   objExcel.columns(7).columnwidth = 16
   objExcel.columns(8).columnwidth = 16
   objExcel.columns(9).columnwidth = 30

'Stcklistenkopf 1
   objExcel.Cells(1,4).Value = ISDGetText("Gosag Stahl- und Anlagenbau GmbH")
   objExcel.Cells(1,7).Value = ISDGetText("Am Vogts Garten 10, D-06308 Klostermansfeld")
   objExcel.Cells(2,4).Value = ISDGetText("ZNR")
   objExcel.Cells(3,4).Value = ISDGetText("ORDERNR")
   objExcel.Cells(4,4).Value = ISDGetText("DESIGNATION")
   objExcel.Cells(2,7).Value = ISDGetText("CUSTOMER")
   objExcel.Cells(3,7).Value = ISDGetText("CREATOR")
   objExcel.Cells(4,7).Value = ISDGetText("DATE")  

'Farbe oberer Bereich
   objExcel.Worksheets(MySheetName1).Range("D1:I1").Interior.Color = RGB(100,180,100)
   objExcel.Cells(1,4).Font.Bold = True
   objExcel.Cells(1,7).Font.Bold = True

'Rahmen
   objExcel.Worksheets(MySheetName1).Range("A1:L5").Borders(xlEdgeLeft).Color = RGB(0,0,0)
   objExcel.Worksheets(MySheetName1).Range("A1:L5").Borders(xlEdgeRight).Color = RGB(0,0,0)
   objExcel.Worksheets(MySheetName1).Range("A1:L5").Borders(xlEdgeTop).Color = RGB(0,0,0)
   objExcel.Worksheets(MySheetName1).Range("A1:L5").Borders(xlEdgeBottom).Color = RGB(0,0,0)
   objExcel.Worksheets(MySheetName1).Range("C1:C4").Borders(xlEdgeRight).Color = RGB(0,0,0)
   objExcel.Worksheets(MySheetName1).Range("D2:D4").Borders(xlEdgeRight).Color = RGB(0,0,0)
   objExcel.Worksheets(MySheetName1).Range("F1:F4").Borders(xlEdgeRight).Color = RGB(0,0,0)
   objExcel.Worksheets(MySheetName1).Range("G2:G4").Borders(xlEdgeRight).Color = RGB(0,0,0)
   objExcel.Worksheets(MySheetName1).Range("H1:I4").Borders(xlEdgeRight).Color = RGB(0,0,0)
   objExcel.Worksheets(MySheetName1).Range("D1:I1").Borders(xlEdgeBottom).Color = RGB(0,0,0)
   objExcel.Worksheets(MySheetName1).Range("D2:I2").Borders(xlEdgeBottom).Color = RGB(0,0,0)
   objExcel.Worksheets(MySheetName1).Range("D3:I3").Borders(xlEdgeBottom).Color = RGB(0,0,0)
   objExcel.Worksheets(MySheetName1).Range("D4:I4").Borders(xlEdgeBottom).Color = RGB(0,0,0)

'Schriftart und Formatierung
   objExcel.Worksheets(MySheetName1).Range("A1:L1").Font.Size = 12
   objExcel.Worksheets(MySheetName1).Range("A2:L4").Font.Size = 10   
   objExcel.Worksheets(MySheetName1).Range("A5:L5").Font.Size = 12
   objExcel.Worksheets(MySheetName1).Range("A5:L5").Font.Bold = true
   objExcel.Worksheets(MySheetName1).Range("B2:B2").Font.Size = 12
   objExcel.Worksheets(MySheetName1).Range("B2:B2").Font.Bold = true
   objExcel.Worksheets(MySheetName1).Range("B2:B2").Font.Underline = true

'Zeichnungsnummer = E2; Bestellnummer = E3; Benennnung = E4
   objExcel.Worksheets(MySheetName1).Range("E2") = GetContent(objExcel,"Header","H__SZNATTRS04",5)
   objExcel.Worksheets(MySheetName1).Range("E3") = GetContent(objExcel,"Header","H__SZNATTRS01",5)
   objExcel.Worksheets(MySheetName1).Range("E4") = GetContent(objExcel,"Header","H__SZNATTRS06",5)

'Kunde = H2; Ersteller = H3; Erstellt am = H4
   objExcel.Worksheets(MySheetName1).Range("H2") = GetContent(objExcel,"Header","H__SZNATTRS03",5)
   objExcel.Worksheets(MySheetName1).Range("H3") = GetContent(objExcel,"Header","H__SZNATTRS08",5)
   objExcel.Worksheets(MySheetName1).Range("H4") = GetContent(objExcel,"Header","H__SZNATTRS09",5)
  
'Druckbereich
   objExcel.Worksheets(MySheetName1).PageSetup.Orientation = 2
   objExcel.Worksheets(MySheetName1).PageSetup.Zoom = 77
   objExcel.Worksheets(MySheetName1).PageSetup.LeftMargin = 20
   objExcel.Worksheets(MySheetName1).PageSetup.RightMargin = 20
   objExcel.Worksheets(MySheetName1).PageSetup.TopMargin = 60
   objExcel.Worksheets(MySheetName1).PageSetup.BottomMargin = 40
   objExcel.Worksheets(MySheetName1).PageSetup.HeaderMargin = 10
   objExcel.Worksheets(MySheetName1).PageSetup.FooterMargin = 10

'Stcklistenkopf 2
   objExcel.Cells(5,1).Value = ISDGetText("POS")
   objExcel.Cells(5,2).Value = ISDGetText("QTY")
   objExcel.Cells(5,3).Value = ISDGetText("DESIGNATION1")
   objExcel.Cells(5,4).Value = ISDGetText("WIDTH")
   objExcel.Cells(5,5).Value = ISDGetText("LENGTH")
   objExcel.Cells(5,6).Value = ISDGetText("WEB_CUT")
   objExcel.Cells(5,7).Value = ISDGetText("FLANGE_CUT")
   objExcel.Cells(5,8).Value = ISDGetText("MATERIAL")
   objExcel.Cells(5,9).Value = ISDGetText("DESIGNATION")
   objExcel.Cells(5,10).Value = ISDGetText("SURFACE")
   objExcel.Cells(5,11).Value = ISDGetText("WEIGHT")
   objExcel.Cells(5,12).Value = ISDGetText("TOTWEIGHT")

'Farbe mittlerer Bereich
   For K = 1 To 12
      objExcel.Cells(5,K).Interior.Color = RGB(100,180,100)
      objExcel.Cells(5,K).Borders.Color = RGB(0,0,0)
   Next
   



'Table
   MyTableLength = GetTableLength(objExcel,ListSource)
   K1 = 4
   For K = 5 To MyTableLength
        If Len(FilterAttribute)>0 Then
        	If Positive Then
        		If MyFilter (GetContent(objExcel,ListSource,FilterAttribute,K)) Then
	        		InTable = True
	        	Else
	        		InTable = False
	        	End If
	        Else
	        	If Not MyFilter (GetContent(objExcel,ListSource,FilterAttribute,K)) Then
	        		InTable = True
	        	Else
	        		InTable = False
	        	End If	        
	        End if
        Else
        	InTable = True
        End If        
        If InTable Then
        	K1 = K1 + 1
	   		objExcel.Worksheets(MySheetName1).Range("A" + Trim(K1 + 1)+":L" + Trim(K1 + 1)).Font.Size = 10    
	   		objExcel.Cells(K1+1,1).Value = GetContent(objExcel,ListSource,"%Posnr",K)   
	   		objExcel.Cells(K1+1,1).Borders.Color = RGB(0,0,0)
	   		objExcel.Cells(K1+1,2).Value = GetContent(objExcel,ListSource,"%Anzahl",K)   
	   		objExcel.Cells(K1+1,2).Borders.Color = RGB(0,0,0)
	   		objExcel.Cells(K1+1,3).Value = GetContent(objExcel,ListSource,"H_$BB",K)   
	   		objExcel.Cells(K1+1,3).Borders.Color = RGB(0,0,0)
	   		objExcel.Cells(K1+1,4).Value = GetContent(objExcel,ListSource,"H_02",K)      
	   		objExcel.Cells(K1+1,4).Borders.Color = RGB(0,0,0)
	   		objExcel.Cells(K1+1,5).Value = GetContent(objExcel,ListSource,"H_03",K)   
	   		objExcel.Cells(K1+1,5).Borders.Color = RGB(0,0,0)   		   		   		   		
	   		objExcel.Cells(K1+1,6).Value = GetContent(objExcel,ListSource,"H_$10",K)   
	   		objExcel.Cells(K1+1,6).Borders.Color = RGB(0,0,0)   	   	
	   		objExcel.Cells(K1+1,7).Value = GetContent(objExcel,ListSource,"H_$09",K)   
	   		objExcel.Cells(K1+1,7).Borders.Color = RGB(0,0,0) 
	   		objExcel.Cells(K1+1,8).Value = GetContent(objExcel,ListSource,"%Material",K)   
	   		objExcel.Cells(K1+1,8).Borders.Color = RGB(0,0,0)    		
'	   		objExcel.Cells(K1+1,9).Value = GetContent(objExcel,ListSource,"H_$02",K)   
	   		objExcel.Cells(K1+1,9).Borders.Color = RGB(0,0,0)       		
	   		objExcel.Cells(K1+1,10).Value = GetContent(objExcel,ListSource,"H_10",K)   
	   		objExcel.Cells(K1+1,10).Borders.Color = RGB(0,0,0)     	
	   		objExcel.Cells(K1+1,11).Value = GetContent(objExcel,ListSource,"H_01",K)   
	   		objExcel.Cells(K1+1,11).Borders.Color = RGB(0,0,0)     	
	   		objExcel.Cells(K1+1,12).Value = GetContent(objExcel,ListSource,"_ATTR_@1",K)   
	   		objExcel.Cells(K1+1,12).Borders.Color = RGB(0,0,0) 	   		
	   	End If
   Next

' Bilder und Logos im Kopf   
'   Set Picture = objExcel.ActiveSheet.Pictures.Insert(MyHomeDir + "PrintDat\hicad.bmp")
'   Picture.ShapeRange.Height = 57
'   Picture.Top = 2
'   Picture.Left = 2
   Set Picture = objExcel.ActiveSheet.Pictures.Insert(MyHomeDir + "PrintDat\Gosag-Logo.jpg")
   Picture.ShapeRange.Height = 57
   Picture.Top = 2
   Picture.Left = 810  
   
   objExcel.Worksheets(MySheetName1).Range("A1:L" + Trim(K1 + 1)).Font.Name = "Arial Narrow"

End Sub


'#########################################################################################
'Schleife fr die Worksheetgenerierung


Set Args = WScript.Arguments
   If Args.Count < 1 Then
		MsgBox ISDGetText("ZU_WENIG_PARAMETER")
   Else
   
	   ISDInitTextService
	
	   strFile = Args(0) 
	   Set objExcel = CreateObject ("Excel.Application")
	   Set objWorkbook = objExcel.Workbooks.Open (strFile)
	   objExcel.Visible = True 
	   
	   InitIndex (objExcel)


'Aluminium Profile
'	   MaxCrit = 1
'	   Crit(1) = "AlCuMg1"
'	   CreateBOM "ALUBEAMS" , "Quantity_List" , "%Material" , True
'	   objExcel.Cells(2,2).Value = ISDGetText("Aluminium Profile")
'          objExcel.Worksheets(MySheetName1).PageSetup.PrintArea = "A:L"

'Edelstahl Profile	   
'	   MaxCrit = 1
'	   Crit(1) = "115CrV3"
'	   CreateBOM "STAINLESSBEAMS" , "Quantity_List" , "%Material" , True
'	   objExcel.Cells(2,2).Value = ISDGetText("Edelstahl Profile")
'          objExcel.Worksheets(MySheetName1).PageSetup.PrintArea = "A:L"	 


'Flachstahl und Profile  
	   MaxCrit = 1
	   Crit(1) = 1
	   CreateBOM "Flachstahl und Profile" , "Quantity_List" , "%KrpModul" , True
	   objExcel.Cells(2,2).Value = ISDGetText("Flachstahl und Profile ")
           objExcel.Worksheets(MySheetName1).PageSetup.PrintArea = "A:L"

'Bleche  
	   MaxCrit = 1
	   Crit(1) = 2
	   CreateBOM "Bleche" , "Quantity_List" , "%KrpModul" , True	
	   objExcel.Cells(2,2).Value = ISDGetText("Bleche")
           objExcel.Worksheets(MySheetName1).PageSetup.PrintArea = "A:L"

'Normteile  
	   MaxCrit = 2
	   Crit(1) = 6
	   Crit(2) = 14
	   CreateBOM "Normteile" , "Quantity_List" , "%KrpModul" , True	   	
	   objExcel.Cells(2,2).Value = ISDGetText("Normteile")	 
           objExcel.Worksheets(MySheetName1).PageSetup.PrintArea = "A:L"

'Mengenliste  
	   MaxCrit = 9
	   Crit(1) = 32
	   Crit(2) = 31
	   Crit(3) = 27
	   Crit(4) = 46
	   Crit(5) = 47
	   Crit(6) = 48
	   Crit(7) = 49
	   Crit(8) = 50
	   Crit(9) = 51
	   CreateBOM "Mengenliste" , "Quantity_List" , "%KrpModul" , False	 	     	   
	   objExcel.Cells(2,2).Value = ISDGetText("Mengenliste")
           objExcel.Worksheets(MySheetName1).PageSetup.PrintArea = "A:L"

'Strukturliste  
	   MaxCrit = 0
	   CreateBOM "STRUCTURELIST" , "Structure_List" , "%KrpModul" , False
	   objExcel.Cells(2,2).Value = ISDGetText("Strukturliste")
           objExcel.Worksheets(MySheetName1).PageSetup.PrintArea = "A:L"

'Versandliste
	   MaxCrit = 9
	   Crit(1) = 32
	   Crit(2) = 31
	   Crit(3) = 27
	   Crit(4) = 46
	   Crit(5) = 47
	   Crit(6) = 48
	   Crit(7) = 49
	   Crit(8) = 50
	   Crit(9) = 51
	   CreateBOM "Versandliste" , "Structure_List" , "%KrpModul" , True
	   objExcel.Cells(2,2).Value = ISDGetText("Versandliste")
           objExcel.Worksheets(MySheetName1).PageSetup.PrintArea = "A:L"
	   		
	   objExcel.DisplayAlerts = False
	   objExcel.Worksheets("Header").Delete
	   objExcel.Worksheets("Quantity_List").Delete
	   objExcel.Worksheets("Structure_List").Delete
	   objExcel.DisplayAlerts = True
	end if